Index: code/branches/main_reto_vs05/scripts/weapon_framework.vcproj
===================================================================
--- code/branches/main_reto_vs05/scripts/weapon_framework.vcproj	(revision 188)
+++ code/branches/main_reto_vs05/scripts/weapon_framework.vcproj	(revision 189)
@@ -41,5 +41,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_HOME)\OgreMain\include&quot;;&quot;$(OGRE_HOME)\Dependencies\include&quot;"
+				AdditionalIncludeDirectories="..\src;..\src\weapon;&quot;$(OGRE_HOME)\OgreMain\include&quot;;&quot;$(OGRE_HOME)\Dependencies\include&quot;"
 				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS"
 				MinimalRebuild="true"
@@ -184,20 +184,12 @@
 			>
 			<File
-				RelativePath="..\src\ammunition_dump.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\src\bullet.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\src\bullet_manager.cc"
-				>
-			</File>
-			<File
 				RelativePath="..\src\camera_manager.cc"
 				>
 			</File>
 			<File
+				RelativePath="..\src\inertial_node.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\src\main.cc"
 				>
@@ -223,8 +215,24 @@
 				>
 			</File>
-			<File
-				RelativePath="..\src\weapon_manager.cc"
-				>
-			</File>
+			<Filter
+				Name="weapon"
+				>
+				<File
+					RelativePath="..\src\weapon\ammunition_dump.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\src\weapon\bullet.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\src\weapon\bullet_manager.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\src\weapon\weapon_manager.cc"
+					>
+				</File>
+			</Filter>
 		</Filter>
 		<Filter
@@ -234,20 +242,12 @@
 			>
 			<File
-				RelativePath="..\src\ammunition_dump.h"
-				>
-			</File>
-			<File
-				RelativePath="..\src\bullet.h"
-				>
-			</File>
-			<File
-				RelativePath="..\src\bullet_manager.h"
-				>
-			</File>
-			<File
 				RelativePath="..\src\camera_manager.h"
 				>
 			</File>
 			<File
+				RelativePath="..\src\inertial_node.h"
+				>
+			</File>
+			<File
 				RelativePath="..\src\ogre_control.h"
 				>
@@ -273,12 +273,28 @@
 				>
 			</File>
-			<File
-				RelativePath="..\src\weapon.h"
-				>
-			</File>
-			<File
-				RelativePath="..\src\weapon_manager.h"
-				>
-			</File>
+			<Filter
+				Name="weapon"
+				>
+				<File
+					RelativePath="..\src\weapon\ammunition_dump.h"
+					>
+				</File>
+				<File
+					RelativePath="..\src\weapon\bullet.h"
+					>
+				</File>
+				<File
+					RelativePath="..\src\weapon\bullet_manager.h"
+					>
+				</File>
+				<File
+					RelativePath="..\src\weapon\weapon.h"
+					>
+				</File>
+				<File
+					RelativePath="..\src\weapon\weapon_manager.h"
+					>
+				</File>
+			</Filter>
 		</Filter>
 		<Filter
Index: code/branches/main_reto_vs05/src/inertial_node.cc
===================================================================
--- code/branches/main_reto_vs05/src/inertial_node.cc	(revision 189)
+++ code/branches/main_reto_vs05/src/inertial_node.cc	(revision 189)
@@ -0,0 +1,126 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OgreSceneNode.h"
+#include "OgreVector3.h"
+
+#include "inertial_node.h"
+
+
+namespace orxonox {
+  using namespace Ogre;
+
+  InertialNode::InertialNode(SceneNode *node, Vector3 speed)
+        : node_(node), speed_(speed), childListSize_(4), childListIndex_(0),
+        parentNode_(NULL)
+  {
+    childList_ = new InertialNode*[childListSize_];
+  }
+
+
+  InertialNode::InertialNode(orxonox::InertialNode *parentNode, Vector3 speed)
+        : parentNode_(parentNode), childListSize_(4), childListIndex_(0), speed_(speed)
+  {
+    childList_ = new InertialNode*[childListSize_];
+    node_ = parentNode_->getSceneNode()->createChildSceneNode();
+  }
+
+
+  InertialNode::~InertialNode()
+  {
+    if (childList_)
+    {
+      for (int i = 0; i < childListIndex_; i++)
+        if (childList_[i])
+          delete childList_[i];
+      delete childList_;
+    }
+  }
+
+
+  InertialNode* InertialNode::createChildNode()
+  {
+    InertialNode *temp = new InertialNode(this);
+    addChild(temp);
+    return temp;
+  }
+
+
+  InertialNode* InertialNode::getParentNode()
+  {
+    return parentNode_;
+  }
+
+
+  SceneNode* InertialNode::getSceneNode()
+  {
+    return node_;
+  }
+
+
+  Vector3 InertialNode::getSpeed()
+  {
+    return speed_;
+  }
+
+
+  Vector3 InertialNode::getWorldSpeed()
+  {
+    // go through the tree of Inertial nodes
+    Vector3 speed = speed_;
+    InertialNode *temp = parentNode_;
+    while (temp != NULL)
+    {
+      speed = temp->getSceneNode()->getOrientation() * speed + temp->getSpeed();
+      temp = temp->getParentNode();
+    }
+    return speed;
+  }
+
+
+  void InertialNode::addSpeed(Vector3 speed)
+  {
+    speed_ += speed;
+  }
+
+
+  void InertialNode::addChild(orxonox::InertialNode *node)
+  {
+    if (childListIndex_ == childListSize_)
+    {
+      // redimension the array
+      InertialNode **tempArray = new InertialNode*[2*childListSize_];
+      for (int i = 0; i < childListSize_; i++)
+        tempArray[i] = childList_[i];
+      childListSize_ *= 2;
+      delete childList_;
+      childList_ = tempArray;
+    }
+    childList_[childListIndex_++] = node;
+  }
+
+}
Index: code/branches/main_reto_vs05/src/inertial_node.h
===================================================================
--- code/branches/main_reto_vs05/src/inertial_node.h	(revision 189)
+++ code/branches/main_reto_vs05/src/inertial_node.h	(revision 189)
@@ -0,0 +1,77 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#ifndef INERTIAL_NODE_H
+#define INERTIAL_NODE_H
+
+#include "OgrePrerequisites.h"
+
+#include "orxonox_prerequisites.h"
+
+
+namespace orxonox {
+
+  class InertialNode
+  {
+  public:
+    InertialNode(Ogre::SceneNode*, Ogre::Vector3);
+	  ~InertialNode();
+
+    InertialNode* createChildNode();
+
+    InertialNode* getParentNode();
+
+    Ogre::SceneNode* getSceneNode();
+
+    Ogre::Vector3 getSpeed();
+
+    Ogre::Vector3 getWorldSpeed();
+
+    void addSpeed(Ogre::Vector3);
+
+  protected:
+    InertialNode(InertialNode*, Ogre::Vector3 speed = Ogre::Vector3::ZERO);
+    void addChild(InertialNode*);
+
+  public:
+
+  protected:
+    InertialNode **childList_;
+    int childListSize_;
+    int childListIndex_;
+
+    Ogre::SceneNode *node_;
+	  Ogre::Vector3 speed_;
+
+    InertialNode* parentNode_;
+
+  };
+
+}
+
+#endif /* INERTIAL_NODE_H */
Index: code/branches/main_reto_vs05/src/orxonox_prerequisites.h
===================================================================
--- code/branches/main_reto_vs05/src/orxonox_prerequisites.h	(revision 188)
+++ code/branches/main_reto_vs05/src/orxonox_prerequisites.h	(revision 189)
@@ -32,8 +32,6 @@
 namespace orxonox {
 
-  class AmmunitionDump;
-  class Bullet;
-  class BulletManager;
   class CameraManager;
+  class InertialNode;
   class OgreControl;
   class Orxonox;
@@ -41,6 +39,15 @@
   class OrxonoxScene;
   class RunManager;
-  class Weapon;
-  class WeaponManager;
+
+
+  namespace weapon {
+
+    class AmmunitionDump;
+    class Bullet;
+    class BulletManager;
+    class Weapon;
+    class WeaponManager;
+
+  }
 
 }
Index: code/branches/main_reto_vs05/src/orxonox_ship.cc
===================================================================
--- code/branches/main_reto_vs05/src/orxonox_ship.cc	(revision 188)
+++ code/branches/main_reto_vs05/src/orxonox_ship.cc	(revision 189)
@@ -34,11 +34,13 @@
 #include "bullet.h"
 #include "bullet_manager.h"
+#include "inertial_node.h"
+#include "weapon_manager.h"
 
 #include "orxonox_ship.h"
-#include "weapon_manager.h"
 
 
 namespace orxonox {
   using namespace Ogre;
+  using namespace weapon;
 
   /**
@@ -65,8 +67,9 @@
   OrxonoxShip::OrxonoxShip(SceneManager *sceneMgr, SceneNode *node,
         BulletManager *bulletManager)
-	      : sceneMgr_(sceneMgr), rootNode_(node), currentSpeed_(Vector3(0, 0, 0)),
+	      : sceneMgr_(sceneMgr), //currentSpeed_(Vector3(0, 0, 0)),
         baseThrust_(1000), currentThrust_(Vector3::ZERO),
         objectCounter_(0), bulletManager_(bulletManager)//, bulletSpeed_(400)
   {
+    rootNode_ = new InertialNode(node, Vector3::ZERO);
   }
 
@@ -80,4 +83,6 @@
     if (mainWeapon_)
       delete mainWeapon_;
+    if (rootNode_)
+      delete rootNode_;
   }
 
@@ -99,12 +104,11 @@
 	  // TODO: names must be unique! use static variables..
 	  shipEntity_ = sceneMgr_->createEntity("Ship", "fish.mesh");
-	  SceneNode *fishNode = rootNode_->createChildSceneNode("fishNode");
-	  fishNode->yaw(Degree(-90));
-	  fishNode->attachObject(shipEntity_);
-	  fishNode->setScale(Vector3(10, 10, 10));
+	  InertialNode *fishNode = rootNode_->createChildNode();
+    fishNode->getSceneNode()->yaw(Degree(-90));
+	  fishNode->getSceneNode()->attachObject(shipEntity_);
+	  fishNode->getSceneNode()->setScale(Vector3(10, 10, 10));
 
     // initialise weapon(s)
-    SceneNode *mainWeaponNode = rootNode_
-          ->createChildSceneNode("mainWeaponNode");
+    InertialNode *mainWeaponNode = rootNode_->createChildNode();
     mainWeapon_ = new WeaponManager(sceneMgr_, mainWeaponNode,
           bulletManager_, 1);
@@ -154,5 +158,5 @@
   void OrxonoxShip::turnUpAndDown(const Radian &angle)
   {
-    rootNode_->pitch(-angle, Node::TS_LOCAL);
+    rootNode_->getSceneNode()->pitch(-angle, Node::TS_LOCAL);
   }
 
@@ -164,5 +168,5 @@
   void OrxonoxShip::turnLeftAndRight(const Radian &angle)
   {
-    rootNode_->yaw(-angle, Node::TS_PARENT);
+    rootNode_->getSceneNode()->yaw(-angle, Node::TS_PARENT);
   }
 
@@ -174,5 +178,5 @@
   Vector3 OrxonoxShip::getSpeed()
   {
-    return currentSpeed_;
+    return rootNode_->getSpeed();
   }
 
@@ -181,5 +185,5 @@
   * @return The Root Node.
   */
-  SceneNode* OrxonoxShip::getRootNode()
+  InertialNode* OrxonoxShip::getRootNode()
   {
     return rootNode_;
@@ -195,16 +199,4 @@
   void OrxonoxShip::fire()
   {
-	  // TODO: Names must be unique!
-	  /*SceneNode *temp = rootNode_->getParentSceneNode()->createChildSceneNode(
-          "BulletNode" + StringConverter::toString(objectCounter_));
-	  temp->setOrientation(rootNode_->getOrientation());
-	  temp->setPosition(rootNode_->getPosition());
-	  temp->setScale(Vector3(1, 1, 1) * 10);
-	  temp->yaw(Degree(-90));
-	  return new Bullet(temp, sceneMgr_->createEntity("bullet"
-          + StringConverter::toString(objectCounter_++), "Barrel.mesh"), currentSpeed_
-          + (rootNode_->getOrientation() * Vector3(0, 0, -1)).normalisedCopy()
-          * bulletSpeed_);*/
-
     mainWeapon_->primaryFireRequest();
   }
@@ -222,9 +214,9 @@
     mainWeapon_->tick(time, deltaTime);
 
-    Quaternion quad = rootNode_->getOrientation();
+    Quaternion quad = rootNode_->getSceneNode()->getOrientation();
     quad.normalise();
-    currentSpeed_ += quad * (Vector3(-1, -1, -1) * currentThrust_) * deltaTime;
-
-	  rootNode_->translate(currentSpeed_ * deltaTime);
+    rootNode_->addSpeed(quad * (Vector3(-1, -1, -1) * currentThrust_) * deltaTime);
+
+    rootNode_->getSceneNode()->translate(rootNode_->getSpeed() * deltaTime);
 
 	  return true;
Index: code/branches/main_reto_vs05/src/orxonox_ship.h
===================================================================
--- code/branches/main_reto_vs05/src/orxonox_ship.h	(revision 188)
+++ code/branches/main_reto_vs05/src/orxonox_ship.h	(revision 189)
@@ -40,5 +40,5 @@
   {
   public:
-	  OrxonoxShip(Ogre::SceneManager*, Ogre::SceneNode*, BulletManager*);
+    OrxonoxShip(Ogre::SceneManager*, Ogre::SceneNode*, weapon::BulletManager*);
 	  virtual ~OrxonoxShip();
 
@@ -51,5 +51,5 @@
 	  void turnLeftAndRight(const Ogre::Radian&);
 
-    Ogre::SceneNode* getRootNode();
+    InertialNode* getRootNode();
     Ogre::Vector3 getSpeed();
 
@@ -62,16 +62,17 @@
   protected:
 	  Ogre::SceneManager *sceneMgr_;
-	  Ogre::SceneNode *rootNode_;
+	  //Ogre::SceneNode *rootNode_;
+    InertialNode *rootNode_;
 	  Ogre::Entity *shipEntity_;
 
-	  Ogre::Vector3 currentSpeed_;  // relative to space
+	  //Ogre::Vector3 currentSpeed_;  // relative to space
 	  Ogre::Vector3 currentThrust_; // relative to the ship
     Ogre::Real baseThrust_;
 	  int objectCounter_;
 
-    BulletManager *bulletManager_;
+    weapon::BulletManager *bulletManager_;
 	  //Ogre::Vector3 bulletSpeed_;
 
-    WeaponManager *mainWeapon_;
+    weapon::WeaponManager *mainWeapon_;
   };
 
Index: code/branches/main_reto_vs05/src/run_manager.cc
===================================================================
--- code/branches/main_reto_vs05/src/run_manager.cc	(revision 188)
+++ code/branches/main_reto_vs05/src/run_manager.cc	(revision 189)
@@ -55,4 +55,5 @@
 #include "camera_manager.h"
 #include "weapon_manager.h"
+#include "inertial_node.h"
 
 #include "run_manager.h"
@@ -60,4 +61,5 @@
 namespace orxonox {
   using namespace Ogre;
+  using namespace weapon;
 
   /**
@@ -572,5 +574,5 @@
   {
     camera_ = sceneMgr_->createCamera("PlayerCam");
-    playerShip_->getRootNode()->attachObject(camera_);
+    playerShip_->getRootNode()->getSceneNode()->attachObject(camera_);
     camera_->setNearClipDistance(5);
     camera_->setPosition(Vector3(0,10,500));
Index: code/branches/main_reto_vs05/src/run_manager.h
===================================================================
--- code/branches/main_reto_vs05/src/run_manager.h	(revision 188)
+++ code/branches/main_reto_vs05/src/run_manager.h	(revision 189)
@@ -112,5 +112,5 @@
 	  int bulletsSize_;
 	  int bulletsIndex_;*/
-    BulletManager *bulletManager_;
+    weapon::BulletManager *bulletManager_;
 
 	  // previously elapsed render time
Index: code/branches/main_reto_vs05/src/weapon/ammunition_dump.cc
===================================================================
--- code/branches/main_reto_vs05/src/weapon/ammunition_dump.cc	(revision 189)
+++ code/branches/main_reto_vs05/src/weapon/ammunition_dump.cc	(revision 189)
@@ -0,0 +1,44 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "ammunition_dump.h"
+
+
+namespace orxonox {
+namespace weapon {
+
+  AmmunitionDump::AmmunitionDump()
+  {
+  }
+
+
+  AmmunitionDump::~AmmunitionDump()
+  {
+  }
+
+}
+}
Index: code/branches/main_reto_vs05/src/weapon/ammunition_dump.h
===================================================================
--- code/branches/main_reto_vs05/src/weapon/ammunition_dump.h	(revision 189)
+++ code/branches/main_reto_vs05/src/weapon/ammunition_dump.h	(revision 189)
@@ -0,0 +1,55 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#ifndef AmmunitionDump_H
+#define AmmunitionDump_H
+
+#include "OgrePrerequisites.h"
+
+#include "orxonox_prerequisites.h"
+
+
+namespace orxonox {
+namespace weapon {
+
+  class AmmunitionDump
+  {
+  public:
+	  AmmunitionDump();
+	  ~AmmunitionDump();
+
+  protected:
+
+  protected:
+
+  };
+
+}
+}
+
+#endif /* AmmunitionDump_H */
Index: code/branches/main_reto_vs05/src/weapon/bullet.cc
===================================================================
--- code/branches/main_reto_vs05/src/weapon/bullet.cc	(revision 189)
+++ code/branches/main_reto_vs05/src/weapon/bullet.cc	(revision 189)
@@ -0,0 +1,51 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OgreSceneNode.h"
+#include "OgreEntity.h"
+#include "OgreVector3.h"
+
+#include "bullet.h"
+
+
+namespace orxonox {
+namespace weapon {
+  using namespace Ogre;
+
+  Bullet::Bullet(SceneNode *node, Entity *entity, Vector3 speed)
+    : node_(node), entity_(entity), speed_(speed)
+  {
+	  node_->attachObject(entity_);
+  }
+
+
+  Bullet::~Bullet()
+  {
+  }
+
+}
+}
Index: code/branches/main_reto_vs05/src/weapon/bullet.h
===================================================================
--- code/branches/main_reto_vs05/src/weapon/bullet.h	(revision 189)
+++ code/branches/main_reto_vs05/src/weapon/bullet.h	(revision 189)
@@ -0,0 +1,60 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#ifndef BULLET_H
+#define BULLET_H
+
+#include "OgrePrerequisites.h"
+
+#include "orxonox_prerequisites.h"
+
+
+namespace orxonox {
+namespace weapon {
+
+  class Bullet
+  {
+  public:
+	  Bullet(Ogre::SceneNode*, Ogre::Entity*, Ogre::Vector3);
+	  ~Bullet();
+
+  protected:
+
+  public:
+    Ogre::SceneNode *node_;
+	  Ogre::Entity *entity_;
+	  Ogre::Vector3 speed_;
+
+  protected:
+
+  };
+
+}
+}
+
+#endif /* BULLET_H */
Index: code/branches/main_reto_vs05/src/weapon/bullet_manager.cc
===================================================================
--- code/branches/main_reto_vs05/src/weapon/bullet_manager.cc	(revision 189)
+++ code/branches/main_reto_vs05/src/weapon/bullet_manager.cc	(revision 189)
@@ -0,0 +1,90 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OgreSceneManager.h"
+
+#include "bullet_manager.h"
+#include "bullet.h"
+
+
+namespace orxonox {
+namespace weapon {
+  using namespace Ogre;
+
+  BulletManager::BulletManager(SceneManager *sceneMgr) : sceneMgr_(sceneMgr),
+        bulletsIndex_(0), bulletsSize_(8)
+  {
+    bullets_ = new Bullet*[bulletsSize_];
+  }
+
+
+  BulletManager::~BulletManager()
+  {
+    // clean up the bullet list
+    if (bullets_)
+    {
+      for (int i = 0; i < bulletsIndex_; i++)
+        delete bullets_[i];
+      delete bullets_;
+    }
+  }
+
+
+  void BulletManager::addBullet(Bullet *bullet)
+  {
+    // resize array if neccessary (double the size then)
+    if (bulletsIndex_ >= bulletsSize_)
+    {
+      // redimension the array
+      Bullet **tempArray = new Bullet*[2*bulletsSize_];
+      for (int i = 0; i < bulletsSize_; i++)
+        tempArray[i] = bullets_[i];
+      bulletsSize_ *= 2;
+      delete bullets_;
+      bullets_ = tempArray;
+    }
+
+    // add the bullet to the list
+    bullets_[bulletsIndex_++] = bullet;
+  }
+
+
+  bool BulletManager::tick(unsigned long time, Real deltaTime)
+  {
+    // update the bullet positions
+    for (int i = 0; i < bulletsIndex_; i++)
+    {
+      bullets_[i]->node_->translate(bullets_[i]->speed_*deltaTime);
+      bullets_[i]->node_->yaw(Degree(deltaTime*100));
+      bullets_[i]->node_->roll(Degree(deltaTime*300));
+    }
+
+    return true;
+  }
+
+}
+}
Index: code/branches/main_reto_vs05/src/weapon/bullet_manager.h
===================================================================
--- code/branches/main_reto_vs05/src/weapon/bullet_manager.h	(revision 189)
+++ code/branches/main_reto_vs05/src/weapon/bullet_manager.h	(revision 189)
@@ -0,0 +1,66 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#ifndef BULLET_MANAGER_H
+#define BULLET_MANAGER_H
+
+#include "OgrePrerequisites.h"
+
+#include "orxonox_prerequisites.h"
+
+
+namespace orxonox {
+namespace weapon {
+
+  class BulletManager
+  {
+  public:
+    BulletManager(Ogre::SceneManager*);
+	  virtual ~BulletManager();
+
+    void addBullet(Bullet*);
+
+    bool tick(unsigned long, Ogre::Real);
+
+  protected:
+
+  public:
+    Ogre::SceneManager *sceneMgr_;
+
+  protected:
+    // Bullet array
+	  Bullet **bullets_;
+	  int bulletsSize_;
+	  int bulletsIndex_;
+
+  };
+
+}
+}
+
+#endif /* BULLET_MANAGER_H */
Index: code/branches/main_reto_vs05/src/weapon/weapon.h
===================================================================
--- code/branches/main_reto_vs05/src/weapon/weapon.h	(revision 189)
+++ code/branches/main_reto_vs05/src/weapon/weapon.h	(revision 189)
@@ -0,0 +1,60 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#ifndef WEAPON_H
+#define WEAPON_H
+
+#include "OgrePrerequisites.h"
+#include "OgreString.h"
+
+#include "orxonox_prerequisites.h"
+
+namespace orxonox {
+namespace weapon {
+
+  class Weapon
+  {
+  public:
+    Weapon(const Ogre::String &name, int firePower, int firingRate,
+      Ogre::Real bulletSpeed)
+          : name_(name), firePower_(firePower), firingRate_(firingRate),
+          bulletSpeed_(bulletSpeed) { }
+
+    virtual ~Weapon() { }
+
+  public:
+    Ogre::String name_;
+    int firePower_;
+    int firingRate_;
+    Ogre::Real bulletSpeed_;
+  };
+
+}
+}
+
+#endif /* WEAPON_H */
